Ray = class()

function Ray:init(startPos,endPos, colour)
    
    self.entity = scene:entity()
    self.entity.model=cylModel
    self.entity.material=craft.material(asset.builtin.Materials.Specular)
    self.entity.material.diffuse=colour
    self.entity.active=false
    self.initialStartPos=startPos
    self.initialEndPos=endPos
    self.startPos=startPos
    self.endPos=endPos  
    self.dir=(endPos-startPos):normalize()
--    local endPos=startPos+startDir*len
    self.entity.position=startPos+(endPos-startPos)/2
    self.entity.scale=vec3(0.01*rayDia, startPos:dist(endPos), 0.01*rayDia)
    self.entity.rotation=quat.fromToRotation(vec3(0,1,0),self.dir)  
        
end

function Ray:update(startPos,endPos,colour)
    self.entity.active=true
    self.startPos=startPos
    self.endPos=endPos
    self.dir=(endPos-startPos):normalize()
    
    self.entity.position=startPos+(endPos-startPos)/2
    self.entity.scale=vec3(0.01*rayDia, startPos:dist(endPos), 0.01*rayDia)
    self.entity.rotation=quat.fromToRotation(vec3(0,1,0),self.dir)  
end

function Ray:draw()
    -- Codea does not automatically call this method
end

function Ray:touched(touch)
    -- Codea does not automatically call this method
end

function refractedRay(incident,normal,n1,n2)
    n=n1/n2    
    cosi=-normal:dot(incident)
    sint2=n*n*(1.0-cosi*cosi)
    if sint2>1.0 then return nil end   --internally reflected
    cost=math.sqrt(1.0-sint2)
    return n*incident+(n*cosi-cost)*normal
end

function makeCylinder()
    
    -- cylinder for photons
    cylMesh = PseudoMesh()   
    cylMesh:addCylinder({
        axis=vec3(0,1,0),
        height=1,
        ends=3,
        size=5,
        --centre=vec3(0,-0.5,0),
        startRadius=1,  endRadius=1,
        --color=color(77, 194, 203, 255),
    })
    cylModel= cylMesh:toModel()   
end
